#Compile Exe
#Dim All

#Debug Display On
#Debug Error On

$Ver = "2.0"

%Unicode=1
#Include "Win32API.inc"
#Include "WinINET.inc"

#Resource Icon Logo, "icons/down.ico"
Global FTPSite$, FTPSiteFolder$, User$, PSW$, HTTPPath$

Function PBMain() As Long
   Local LocalFileNamePath, LocalFilePath, BinaryHTTPPath As WStringZ*%Max_Path, iResult As Long
   Local BinaryFilepath$, BinaryFileName$, temp$, hBMP As Dword

   If IsFolder (Exe.Path$ + "temp") = %False Then MkDir Exe.Path$ + "temp"
   GetFTPSettings

   LocalFileNamePath   = Exe.Path$ + "temp\binaryfilename.txt
   BinaryHTTPPath  = Left$(HTTPPath$, InStr(-1,HTTPPath$,"/")) + "binaryfilename.txt"

   DeleteURLCacheEntry(BinaryHTTPPath)   'clear the cache
   If URLDownloadToFile (Nothing, BinaryHTTPPath, LocalFileNamePath, 0, Nothing) = 0 Then
      Open LocalFileNamePath For Input As #1 : Line Input #1, BinaryFileName$ : Close #1
      If IsFile(LocalFileNamePath) Then Kill LocalFileNamePath
      If Len(Trim$(BinaryFileName$)) Then
         LocalFilePath  = Exe.Path$ + "temp\" + BinaryFileName$
         BinaryHTTPPath = Left$(HTTPPath$, InStr(-1,HTTPPath$,"/")) + BinaryFileName$
         DeleteURLCacheEntry((BinaryHTTPPath))   'clear the cache
         URLDownloadToFile (Nothing, BinaryHTTPPath, LocalFilePath, 0, Nothing)
         ShellExecute 0, "Open", PathName$(Path,LocalFilePath), $Nul, $Nul, %SW_Restore
         WinBeep (300,500)
         Exit Function
      Else
         'no binary file (a binary file may exist on the server but is not the the last file uploaded)
      End If
   Else
      WinBeep(300,500)
      MsgBox "gbInternetClipboard data type unknown!", %MB_Ok Or %MB_IconInformation, "gbInternetClipboard"
      Exit Function
   End If

   LocalFilePath = Exe.Path$ + "temp\clipboard.dat"
   DeleteURLCacheEntry((HTTPPath$))   'clear the cache
   If URLDownloadToFile (Nothing, (HTTPPath$), LocalFilePath, 0, Nothing) = 0 Then
      Open LocalFilePath For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
      Clipboard Reset
      If Left$(temp$,2) = "BM" Then
         Graphic Bitmap Load LocalFilePath, 0, 0 To hBMP   'put bitmap on clipboard
         Clipboard Set Bitmap hBMP
      Else
         Clipboard Set Text temp$                      'put text on clipboard
      End If
      WinBeep(300,500)                                 'just to say I'm done
      If IsFile(LocalFilePath) Then Kill LocalFilePath
   Else
      MsgBox "gbInternetClipboard text file not found!", %MB_Ok Or %MB_IconInformation, "gbInternetClipboard"
   End If
End Function

Sub GetFTPSettings
   Open Exe.Path$ + "ftpsettings.txt" For Input As #1
   Line Input #1, HTTPPath$           'HTTP download path for gbGet
   Line Input #1, FTPSite$            'FTP site, such as ftp.webhero.com
   Line Input #1, FTPSiteFolder$      'FTP site folder, such as /public_html/clipboard/
   Line Input #1, User$               'FTP logon user name
   Line Input #1, PSW$                'FTP logon password
   Close #1
End Sub
