#Compile Exe
#Dim All

#Debug Display On
#Debug Error On

$Ver = "2.0"

%Unicode=1
#Include "Win32API.inc"

#Resource Icon Logo, "icons/up.ico"
Global FTPSite$, FTPSiteFolder$, User$, PSW$, HTTPPath$

Function PBMain() As Long
   Local temp$, BitmapResult, TextResult As Long,hBMP As Dword, BinaryFileName$, LocalFileName$

   GetFTPSettings
   If IsFolder (Exe.Path$ + "temp") = %False Then MkDir Exe.Path$ + "temp"

   'if there is one, place the binary file name on the FTP server in a
   BinaryFileName$ = Exe.Path$ + "temp\binaryfilename.txt"  'the filename on the FTP server containing the binary file name
   If Len(Command$) Then
      LocalFileName$ = Command$
      Open BinaryFileName$ For Output As #1 : Print #1, PathName$(Namex,LocalFileName$); : Close #1
      FTPPut BinaryFileName$
      FTPPut LocalFileName$
      WinBeep(300,500)       'just to say I'm done
      If IsFile(BinaryFileName$) Then Kill BinaryFileName$  'remove text file containing the name of the binary file
      Exit Function
   Else
      Open BinaryFileName$ For Output As #1 : Print #1, $Spc; : Close #1   'create 1-byte file
      FTPPut BinaryFileName$
      If IsFile(BinaryFileName$) Then Kill BinaryFileName$  'remove text file containing the name of the binary file
   End If

   'figure out what kind of information is on the local clipboard
   Clipboard Get Bitmap To hBMP, BitmapResult
   Clipboard Get Text To temp$, TextResult
   LocalFileName$ = Exe.Path$ + "temp\clipboard.dat"  'will contain a bitmap or text, whichever is found in clipboard
   If BitmapResult Then
      'bitmap found on clipboard - save to file then send to server
      Graphic Attach hBMP, 0
      Graphic Save LocalFileName$  'file is a *.bmp. will rename when download
      FTPPut LocalFileName$
   ElseIf TextResult Then
      'text found on clipboard - save to file then send to server
      Open LocalFileName$ For Output As #1 : Print #1, temp$; : Close #1
      FTPPut LocalFileName$
   Else
      'something other than text or bitmap was found - take no action
      MsgBox "Clipboard content is not text or bitmap!", %MB_Ok Or %MB_IconInformation, "gbInternetClipboard"
   End If
   If IsFile(LocalFileName$) Then Kill LocalFileName$  'remove temporary clipboard content file
   WinBeep(300,500)       'just to say I'm done
End Function

Sub FTPPut(FTPFileName$)
   'Stuart McLachian
   Local q As String * 1, ff As Long, FTPCommandsFileName$
   q= """"
   'run command line FTP
   FTPCommandsFileName$ = "FTPCommands.txt"
   Open FTPCommandsFileName$ For Output As #1
   Print #1, "open " + FTPSite$
   Print #1, User$
   Print #1, PSw$
   Print #1, "cd " & FTPSiteFolder$
   Print #1, "lcd " & q & Exe.Path$ & q
   Print #1, "binary"
   Print #1, "put " & q & FTPFileName$ & q
   Print #1, "bye"
   Close #1

   Shell "ftp.exe -s:" + FTPCommandsFileName$, 0
   If IsFile(FTPCommandsFileName$) Then Kill FTPCommandsFileName$   'optional to remove temporary FTP commands file
End Sub

Sub GetFTPSettings
   Open Exe.Path$ + "ftpsettings.txt" For Input As #1
   Line Input #1, HTTPPath$           'HTTP download path for gbGet
   Line Input #1, FTPSite$            'FTP site, such as ftp.webhero.com
   Line Input #1, FTPSiteFolder$      'FTP site folder, such as /public_html/clipboard/
   Line Input #1, User$               'FTP logon user name
   Line Input #1, PSW$                'FTP logon password
   Close #1
End Sub
